#!/bin/bash -e

SOURCE="$1"
TARGET="$2"
CMD="$3"
COMMIT_MSG="$4"

TMPFOLDER=`mktemp -d`

cd $TMPFOLDER
echo "Getting target branch ($TARGET)..."
bzr branch $TARGET target

# merge
echo "Merging source branch ($SOURCE) into target..."
cd target
bzr merge $SOURCE

# run tests
echo "Running tests..."
$CMD

# commit
echo "Committing merge..."
bzr commit -m "$COMMIT_MSG"

# push merge
echo "Pushing merge..."
bzr push $TARGET

echo "SUCCESS"
