from datetime import datetime

from django.core.exceptions import ValidationError
from django.contrib.auth.models import User
from django.db import models

from repos.services import SERVICES


def service_url_validator(value):
    if not any(getattr(s, 'is_valid_url')(value)
               for s in SERVICES.itervalues()):
        raise ValidationError('%s is not a valid service url' % value)


class Project(models.Model):

    owner = models.ForeignKey(User)
    url = models.URLField()
    name = models.TextField()


class RunLog(models.Model):

    project = models.ForeignKey(Project)
    timestamp = models.DateTimeField(default=datetime.utcnow)
    raw = models.TextField()
